from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, Directory, Boolean

Metabin_V0_1_0 = CommandToolBuilder(tool="metabin", base_command=["metabin"], inputs=[ToolInput(tag="in_input", input_type=File(optional=True), prefix="--input", doc=InputDocumentation(doc="TSV file name")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="--out", doc=InputDocumentation(doc="output file prefix")), ToolInput(tag="in_species", input_type=Int(optional=True), prefix="--Species", doc=InputDocumentation(doc="species %id threshold [default= 96]")), ToolInput(tag="in_genus", input_type=Int(optional=True), prefix="--Genus", doc=InputDocumentation(doc="genus %id threshold [default= 92]")), ToolInput(tag="in_family", input_type=Int(optional=True), prefix="--Family", doc=InputDocumentation(doc="family %id threshold [default= 90]")), ToolInput(tag="in_above_f", input_type=Int(optional=True), prefix="--AboveF", doc=InputDocumentation(doc="above family %id threshold [default= 89]")), ToolInput(tag="in_db", input_type=Directory(optional=True), prefix="--db", doc=InputDocumentation(doc="directory containing the taxonomy db (nodes.dmp and names.dmp) [default= /usr/local/bin/../db/]")), ToolInput(tag="in_species_neg_filter", input_type=File(optional=True), prefix="--SpeciesNegFilter", doc=InputDocumentation(doc="negative filter (file with one word per line) [default= NULL]")), ToolInput(tag="in_species_bl", input_type=File(optional=True), prefix="--SpeciesBL", doc=InputDocumentation(doc="species blacklist (file with one taxid per line) [default= NULL]")), ToolInput(tag="in_genus_bl", input_type=File(optional=True), prefix="--GenusBL", doc=InputDocumentation(doc="genera blacklist (file with one taxid per line) [default= NULL]")), ToolInput(tag="in_family_bl", input_type=File(optional=True), prefix="--FamilyBL", doc=InputDocumentation(doc="families blacklist (file with one taxid per line) [default= NULL]")), ToolInput(tag="in_filter_file", input_type=File(optional=True), prefix="--FilterFile", doc=InputDocumentation(doc="file name with the entries from the input to exclude (on entry per line)  [default= NULL]")), ToolInput(tag="in_filter_col", input_type=File(optional=True), prefix="--FilterCol", doc=InputDocumentation(doc="Column name to look for the values found the the file provided in the --Filter parameter  [default= sseqid]")), ToolInput(tag="in_to_paf", input_type=Int(optional=True), prefix="--TopAF", doc=InputDocumentation(doc="TODO above family? [default= 1]")), ToolInput(tag="in_no_mbk", input_type=File(optional=True), prefix="--no_mbk", doc=InputDocumentation(doc="Do not use mbk: codes in the output file to explain why a sequence was not binned at a given level (NA is used throughout)")), ToolInput(tag="in_sp_discard_sp", input_type=Boolean(optional=True), prefix="--sp_discard_sp", doc=InputDocumentation(doc="Discard species with sp. in the name")), ToolInput(tag="in_sp_discard_mtt_wow", input_type=Boolean(optional=True), prefix="--sp_discard_mt2w", doc=InputDocumentation(doc="Discard species with more than two words")), ToolInput(tag="in_sp_discard_num", input_type=Boolean(optional=True), prefix="--sp_discard_num", doc=InputDocumentation(doc="Discard species with numbers")), ToolInput(tag="in_minimal_cols", input_type=Boolean(optional=True), prefix="--minimal_cols", doc=InputDocumentation(doc="Include only the seqid and lineage information in the output table [FALSE]"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="output file prefix")), ToolOutput(tag="out_no_mbk", output_type=File(optional=True), selector=InputSelector(input_to_select="in_no_mbk", type_hint=File()), doc=OutputDocumentation(doc="Do not use mbk: codes in the output file to explain why a sequence was not binned at a given level (NA is used throughout)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Metabin_V0_1_0().translate("wdl", allow_empty_container=True)

